var inverseOverrides = {
  InverseCalendarCardEditOverlayInited: false,
  SetCardValues: this.SetCardValues,
  GetCardValues: this.GetCardValues
};

this.InverseGetCardAb = function () {
  var uri;
  if (gEditCard.abURI)
    uri = gEditCard.abURI;
  else {
    var popup = document.getElementById('abPopup');
    uri = popup.getAttribute('value');
  }

  return GetDirectoryFromURI(uri);
}

this.SetCardValues = function (cardproperty, doc) {
  var addressBook = this.InverseGetCardAb();
  if (!addressBook.isRemote) {
    try {
      var card = gEditCard.card.QueryInterface(Components.interfaces.nsIAbMDBCard);
      var fbUrlInput = document.getElementById("FbUrl");
      card.setStringAttribute("calFBURL", fbUrlInput.value);
    }
    catch (e) {
//       cardproperty.setCardValue("calFBURL", fbUrlInput.value);
    }
  }

  inverseOverrides.SetCardValues(cardproperty, doc);
}

this.readLdapFbUrl = function (input) {
  var prefs = Components.classes["@mozilla.org/preferences;1"]
                .getService(Components.interfaces.nsIPref);
  var branch = gEditCard.abURI.split("://")[1];
  var uriSpec = prefs.GetCharPref(branch + ".uri");
  var uri = Components.classes["@mozilla.org/network/ldap-url;1"].createInstance(Components.interfaces.nsILDAPURL);
  uri.spec = uriSpec;
  uri.filter = "(cn=" + gEditCard.card.displayName + ")";
  uri.setAttributes(1, ["calFBURL"]);
  var ldapQuery = Components.classes["@mozilla.org/ldapsyncquery;1"]
                    .createInstance(Components.interfaces.nsILDAPSyncQuery);
  var result = ldapQuery.getQueryResults(uri, 3);
  if (result)
    input.value = result.split("=")[1];
}

this.GetCardValues = function (cardproperty, doc) {
  inverseOverrides.GetCardValues(cardproperty, doc);
  var fbUrlInput = document.getElementById("FbUrl");

  var addressBook = this.InverseGetCardAb();
  if (addressBook.isRemote) {
    fbUrlInput.disabled = true;
    fbUrlInput.disabledforreadonly = true;
    fbUrlInput.value = "";
    this.readLdapFbUrl(fbUrlInput);
  }
  else {
    try {
      var card = gEditCard.card.QueryInterface(Components.interfaces.nsIAbMDBCard);
      fbUrlInput.value = card.getStringAttribute("calFBURL");
    }
    catch (e) {};
  }
}
